/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 10 juin 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */

package org.omg.lifl.eclipse.plugin.project.utils.SWT;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Listener;


/**
 * This abstract class is used to make a basic SWT area 
 * which allow configuration of some preferences store in a SetterGroupPreference
 *      this basic SWT use a check button to set its visibility  
 * 
 * @author offroy@lifl.fr
 *
 * @version 0.1
 */
public abstract class DirectoryChooserCheck extends DirectoryChooser {

    protected Button _checkButton;
    protected Listener _checkListener;

    /**
     * Constructor
     * @param parent is the SWT parent group
     * @param preference the preferences to manage 
     */
    public DirectoryChooserCheck(Group parent, SetterGroupPreference preference) {
        super(parent, preference);
    }
    
    /* (non-Javadoc)
     * @see org.omg.lifl.plugin.project.utils.SWT.DirectoryChooser#setCheckButton()
     */
    protected void setCheckButton() {
        _checkButton = new Button(subGroup,SWT.CHECK);
        _checkButton.setSelection(subGroupVisible);
        _checkButton.addListener(SWT.Selection, _checkListener = new Listener() {
            public void handleEvent(Event e) {
                subGroupVisible = _checkButton.getSelection();
                if (subGroup != null){ 
                    _text.setVisible(subGroupVisible);
                    _label.setVisible(subGroupVisible);
                    _btnChooser.setVisible(subGroupVisible);
                    get_preference().setEnable(subGroupVisible);
                }else //TODO do something when there is no subGroup
                    ;
                }
            });

    }

}
