/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy, Areski Flissi.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.ccm.filetransfer.browser;

import javax.swing.JOptionPane;

import org.objectweb.ccm.filetransfer.Channel;
import org.objectweb.ccm.filetransfer.ChannelHome;
import org.objectweb.util.browser.api.ExtendedActionEvent;
import org.objectweb.util.browser.api.ExtendedActionListener;
import org.omg.Components.CreateFailure;

/**
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *         <a href="mailto:Areski.Flissi@lifl.fr">Areski Flissi</a>
 * @version 0.1
 */
public class ChannelCreationAction implements ExtendedActionListener {

    public void actionPerformed(ExtendedActionEvent e) {
        String name = "";
        while (name != null && name.equals("")) {
            name = JOptionPane.showInputDialog("Enter the Channel name :");
        }
        if (name != null) {
            ChannelHome channel = (ChannelHome) e.getCurrentValue();
            try {
                Channel c = channel.create();
                c.the_name(name);
            } catch (CreateFailure e1) {
                JOptionPane.showMessageDialog(null, e1.getMessage(), "Create Failure", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

}
