/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy, Areski Flissi.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.ccm.filetransfer.browser;

import java.awt.Component;
import javax.swing.JOptionPane;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;

import org.objectweb.ccm.filetransfer.Prog;
import org.objectweb.ccm.filetransfer.ProgHome;
import org.objectweb.openccm.browser.menu.FileChooserBox;
import org.objectweb.openccm.browser.menu.OpenCCMBrowserConstants;
import org.objectweb.util.browser.api.ExtendedActionEvent;
import org.objectweb.util.browser.api.ExtendedActionListener;
import org.omg.Components.Deployment.ComponentServer;

/**
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *         <a href="mailto:Areski.Flissi@lifl.fr">Areski Flissi</a>
 * @version 0.1
 */
public class ProgCreationAction implements ExtendedActionListener {

    public void actionPerformed(ExtendedActionEvent e) throws Exception {
        ProgHome ph = (ProgHome) e.getCurrentValue();

        Object[] options = { "Create", "Cancel" };
        FileChooserBox fcb = new FileChooserBox("Dir : ", OpenCCMBrowserConstants.DIRECTORY_FILE_CHOOSER);
        int result = JOptionPane.showOptionDialog((Component) e.getActionEvent().getSource(), fcb, "Choose a Program directory",                                                                        JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE,
	                                             null, options, options[0]);
        if (result == 0) {

            File f = fcb.getFile();
            if (f != null && f.exists()) {
	    String name = f.getName();
                  
            Prog p = ph.create();
            p.the_name(name);
            
            } else {
                throw new Exception("You must select a directory !");
            }
            
            
        }
    }

}