/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment;

public class ComponentInstallationMain  extends org.objectweb.ccm.CORBA.ApplicationServer
{
    
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    
    /**
     ** To store the component server name.
     **/
    protected String name_ ="ComponentInstallation";
    
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    
    /**
     **  The constructor.
     **/
    public
	ComponentInstallationMain()
    {
    }
    
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     **  The bootstrap main method.
     **
     **  @param args The command-line arguments.
     **/
    public static void
	main(String args[])
    {
	ComponentInstallationMain server = new ComponentInstallationMain();
	int status = server.start(args);
	System.exit(status);
    }
    
    // ==================================================================
    //
    // Methods for the org.objectweb.ccm.CORBA.ApplicationServer.
    //
    // ==================================================================
    
    /**
     **  Before running the CORBA::ORB.
     **
     **  @param args The command line arguments.
     **
     **  @return The status.
     **/
    public int
    before_run(String[] args)
    {
	// Init the OpenCCM Components runtime.
	org.objectweb.ccm.Components.Runtime.init();
	
	// Create the server servant.
	ComponentInstallationImpl afi = new ComponentInstallationImpl(args[1]+name_+args[0]);
	
	// Activate it.
	org.omg.CORBA.Object ref =
            afi._this_object(org.objectweb.ccm.CORBA.TheORB.getORB());
	
	org.omg.Components.Deployment.ComponentInstallation serverRef = 
		org.omg.Components.Deployment.ComponentInstallationHelper.narrow(ref);
	
	/* args [0] non du fichier a ecrire
	 * args[1] nom de la machine locale
	 */ 
	// Obtain the Name Service.
	org.objectweb.ccm.CORBA.NamingContext ns =
	    org.objectweb.ccm.CORBA.TheNameService.getNamingContext();
	
	// Bind the server object in the name service.
	ns.rebind(name_+args[0], serverRef);
	
	// Output the IOR of the ServerActivator.
	//org.objectweb.ccm.CORBA.TheORB.save_IOR(serverRef,name_);

	// Return OK.
	TheComponentInstallation.setComponentInstallation(serverRef);			
	System.out.println("The OpenCCM Component Instantiation is ready.");
	return 0;
    }
    
    /**
     **  After running the CORBA::ORB.
     **/
    public void
	after_run()
    {
	// Obtain the Name Service.
	org.objectweb.ccm.CORBA.NamingContext ns =
	    org.objectweb.ccm.CORBA.TheNameService.getNamingContext();

	// Unbind the server object from the name service.
	ns.unbind(name_);	
    }	
	
}
