/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm;

import org.objectweb.ccm.descriptor.componentassembly.beans.*;
import org.objectweb.ccm.descriptor.componentassembly.*;
import org.objectweb.ccm.descriptor.softpkg.*;
import org.objectweb.ccm.descriptor.softpkg.beans.*;

public class ComponentfileDeployer {

    private ComponentassemblyBean assemblyObject ;

    /**
     * DeployPartial method goal is to gather component information and invoke
     * deployPartial method on possible imbricated component.
     * If the files point by the tags fileinarchive is a .CSD file the component
     * informations are load and save in the deployTable, else if the file is a .CAD
     * file the componentAssembly is load and store into the ComponentFileDeployer, then
     * a call to deployPartial on the componentAssembly is done. This call will initialize
     * the instance of imbricated CAD.
     */
    public void deployPartial(java.util.Hashtable deployTable, Componentfile cfi)
    {
        try{
        // Init the file to load
        java.io.File softpkgFile
        = new java.io.File (/*((String)deployTable.get("BaseDir"))+*/
                    cfi.getFileinarchive().getName());

        //Test if the file is a csd or a cad file
        if(cfi.getFileinarchive().getName().endsWith(".csd")){
        SoftpkgBean soft=SoftpkgBeanImpl.unmarshalBean(softpkgFile);

        //Browse all the implementation to store the reference of Java implementation
        for(java.util.Iterator i=soft.getImplementationList().iterator();i.hasNext();){
            ImplementationImpl ii=(ImplementationImpl)i.next();
            if(((Programminglanguage)ii.getProgramminglanguageList()
            .get(0)).getName().equalsIgnoreCase("java"))
            {
                deployTable.put(ii.getId(),ii);
            }
        }

        deployTable.put(cfi.getId(),soft);

        }
        else if(cfi.getFileinarchive().getName().endsWith(".cad")){
        /* The file is a cad, the loading of the componentassembly*/
        assemblyObject
            = ComponentassemblyBeanImpl.unmarshalBean(softpkgFile);

        /* Do the first part componentassembly deployment*/
        ((ComponentassemblyDeployer)
         assemblyObject
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deployPartial(deployTable,assemblyObject);
        /*store the componentassembly*/
        deployTable.put(cfi.getId(),assemblyObject);
        }

    }
    catch(Exception e){ e.printStackTrace() ;
    // trower l'exception et la tracer au bon endroit
    }
    }

    /**
     * If a imbricated cad is point, the connections between component is done throw
     * the call of deployFinal on imbricated componentassembly.
     * If the pointed file is a csd nothing to do.
     */
    public void deployFinal(java.util.Hashtable deployTable, Componentfile cfi)
    {
    if(cfi.getFileinarchive().getName().endsWith(".cad")){
        ((ComponentassemblyDeployer)
         ((ComponentassemblyBean)deployTable.get(cfi.getId()))
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deployFinal(deployTable,assemblyObject);
    }
    }

    /**
     * Just remove from hashtable the tree representation of .CSD
     */
    public void tearDownConnections(java.util.Hashtable deployTable, Componentfile cfi)
    {
    if(cfi.getFileinarchive().getName().endsWith(".cad")){
        ((ComponentassemblyDeployer)
         ((ComponentassemblyBean)deployTable.get(cfi.getId()))
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDownConnections(deployTable,(ComponentassemblyBeanImpl)assemblyObject);
    }
    }

    /**
     * Just remove from hashtable the tree representation of .CSD
     */
    public void tearDownInstantiations(java.util.Hashtable deployTable, Componentfile cfi){
    if(cfi.getFileinarchive().getName().endsWith(".cad")){
        ((ComponentassemblyDeployer)
         ((ComponentassemblyBean)deployTable.get(cfi.getId()))
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDownInstantiations(deployTable,(ComponentassemblyBeanImpl)assemblyObject);
    }
    deployTable.remove(cfi.getId());
    }
}
