/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm;

import org.objectweb.ccm.descriptor.componentassembly.beans.*;
import org.objectweb.ccm.descriptor.componentassembly.*;

public class HostcollocationDeployer{
    
    /**
     * Hostcollocation deploy method simply browse all its children and call their 
     * deploy method. The children include processcollocation and homeplacement. For
     * the homeplacement a destination is precised to wrapped an eventual destination
     * precise into the homeplacement. The call to deploy method are done with the 
     * extension manager tool.
     */
    public void deploy(java.util.Hashtable deployTable, Hostcollocation hci ){
    
    for( java.util.Iterator i= hci.getHomeplacementList().iterator(); i.hasNext();){
        //((HomeplacementImpl)i.next()).deploy(deployTable,hci.getDestination().getValue());    
        HomeplacementBean current=(HomeplacementBean)i.next();
        ((HomeplacementDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deploy(deployTable,hci.getDestination(),current);
        }
    }
    
    /**
     * TearDown simply recursively call the teardown method on each children
     */
    public void tearDown(java.util.Hashtable deployTable, Hostcollocation hci ){
    // !! pb imbrication of collocation to resolve
    for( java.util.Iterator i= hci.getHomeplacementList().iterator(); i.hasNext();){
        //((HomeplacementImpl)i.next()).tearDown(deployTable,hci.getDestination().getValue());    
        
        HomeplacementBean current=(HomeplacementBean)i.next();
        ((HomeplacementDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDown(deployTable,hci.getDestination(),current);
    }
    }
}
