/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm;

import org.objectweb.ccm.descriptor.componentassembly.beans.*;
import org.objectweb.ccm.descriptor.componentassembly.*;

public class PartitioningDeployer {

    /**
     * The partition deploy method is in charge to deploy all the collocation
     * ,processcollocation and homeplacement. For the homeplacement none destination
     * are precise to consider its own destination.
     */
    public void deploy(java.util.Hashtable deployTable,Partitioning pi){
    // deployement of the collocation list
    for(java.util.Iterator i=pi.getHostcollocationList().iterator(); i.hasNext();){
        //    ((HostcollocationImpl)i.next()).deploy(deployTable);
        HostcollocationBean current=(HostcollocationBean)i.next();
        ((HostcollocationDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deploy(deployTable,current);    
    }
    //deployement of the processlocation list
    for(java.util.Iterator i=pi.getProcesscollocationList().iterator(); i.hasNext();){
        //    ((ProcesscollocationImpl)i.next()).deploy(deployTable);    
        ProcesscollocationBean current=(ProcesscollocationBean)i.next();
        ((ProcesscollocationDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deploy(deployTable,current);
    }
    //deployement of the homeplacement list
    for(java.util.Iterator i=pi.getHomeplacementList().iterator(); i.hasNext();){
        //    ((HomeplacementImpl)i.next()).deploy(deployTable,null);        
        HomeplacementBean current=(HomeplacementBean)i.next();
        ((HomeplacementDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deploy(deployTable,null,current);
    }
    
    }
    
    /**
     * To exactly the same thing than deploy but call the tearDown method
     */    
    public void tearDown(java.util.Hashtable deployTable,Partitioning pi){
    // deployement of the collocation list
    for(java.util.Iterator i=pi.getHostcollocationList().iterator(); i.hasNext();){
        //    ((HostcollocationImpl)i.next()).tearDown(deployTable);    
        HostcollocationBean current=(HostcollocationBean)i.next();
        ((HostcollocationDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDown(deployTable,current);
    }
    //deployement of the processlocation list
    for(java.util.Iterator i=pi.getProcesscollocationList().iterator(); i.hasNext();){
        //    ((ProcesscollocationImpl)i.next()).deploy(deployTable);    
        ProcesscollocationBean current=(ProcesscollocationBean)i.next();
        ((ProcesscollocationDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDown(deployTable,current);
    }
    //deployement of the homeplacement list
    for(java.util.Iterator i=pi.getHomeplacementList().iterator(); i.hasNext();){
        //    ((HomeplacementImpl)i.next()).deploy(deployTable,null);        
        HomeplacementBean current=(HomeplacementBean)i.next();
        ((HomeplacementDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDown(deployTable,null,current);
    }
        
    }
    
}

