/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.Components;

import org.omg.Components.CCMObject;
import org.omg.Components.PublisherDescription;

/**
 * This class is composed of two objects :<br>
 * <ul>
 * <li>A PublisherDescription reference</li>
 * <li>His associated component</li>
 * </ul>
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class PublisherContainer {

    /** The PublisherDescription reference */
    protected PublisherDescription publisher_;

    /** The PublisherDescription's associated component */
    protected CCMObject component_;

    /**
     * Gets the PublisherDescription's associated component.
     * @return
     */
    public CCMObject getComponent() {
        return component_;
    }

    /**
     * Gets the PublisherDescription reference.
     * @return
     */
    public PublisherDescription getPublisher() {
        return publisher_;
    }

    /**
     * Sets the PublisherDescription's associated component.
     * @param object
     */
    public void setComponent(CCMObject component) {
        component_ = component;
    }

    /**
     * Sets the PublisherDescription reference.
     * @param description
     */
    public void setPublisher(PublisherDescription publisher) {
        publisher_ = publisher;
    }

}
