/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.Deployment;

import java.awt.Component;
import javax.swing.JOptionPane;
import java.io.File;

import org.objectweb.openccm.browser.menu.FileChooserPanel;
//import org.objectweb.openccm.browser.menu.JarFileFilter;
import org.objectweb.openccm.browser.menu.OpenCCMBrowserConstants;
import org.objectweb.util.browser.api.ExtendedActionEvent;
import org.objectweb.util.browser.api.ExtendedActionListener;
import org.omg.Components.Deployment.InvalidLocation;
import org.omg.Components.Deployment.InstallationFailure;
import org.omg.Components.Deployment.ComponentInstallation;

/**
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class InstallOnComponentInstallation implements ExtendedActionListener {

    public void actionPerformed(ExtendedActionEvent e) throws Exception {
        ComponentInstallation c = (ComponentInstallation) e.getCurrentValue();
        Object[] options = { "Create", "Cancel" };
        FileChooserPanel fcp = new FileChooserPanel("UUID : ", "Jar file : ", OpenCCMBrowserConstants.JAR_FILE_CHOOSER);
        int result = JOptionPane.showOptionDialog((Component) e.getActionEvent().getSource(), fcp, "Installation", JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE, null, options, options[0]);
        if (result == 0) {
            String uuid = fcp.getLabel();
            File f = fcp.getFile();
            String fileName = null;
            if (f != null)
                fileName = f.toString();
            if (uuid != null && fileName != null) {
                c.install(uuid, fileName);
            } else {
                throw new Exception("At least one parameter is missing !");
            }
        }
    }

}
