/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.menu;

/**
 * A collection of constants used for managing OpenCCM browser GUI
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class OpenCCMBrowserConstants {

    /** JFileChooser with a Jar FileFilter */
    public static final int JAR_FILE_CHOOSER = 1;

    /** JFileChooser with an XML FileFilter */
    public static final int XML_FILE_CHOOSER = JAR_FILE_CHOOSER + 1;

    /** JFileChooser with an IOR FileFilter */
    public static final int IOR_FILE_CHOOSER = XML_FILE_CHOOSER + 1;
    
    /** JFileChooser wich allow to select only directories */
    public static final int DIRECTORY_FILE_CHOOSER = IOR_FILE_CHOOSER + 1; 

}
