/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.monolog.provider.lib.topics;

/**
 * @author Jerome Offroy
 *
 * Singleton class enclosing the unique TopicsMap to use
 * 
 */
public class TopicsMapSingleton {
	protected static TopicsPool tm_;

    /**
     * get the unique TopicsMap for the current JVM
     * @return TopicsMap
     */
     static public TopicsPool getTopicsMap(){
        if (tm_ == null) {
            tm_ = new TopicsMap();   
        }
        return tm_;    
    }
}